# Copyright (c) 2000-2010, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

%bcond_with apiviz
%bcond_without repolib

%define section free
%define reltag .GA_redhat_1
%define namedreltag .GA-redhat-1
%global namedversion %{version}%{?namedreltag}

Name:           jboss-seam-int
Version:        6.0.0
Release:        6%{?reltag}%{?dist}
Epoch:          0
Summary:        JBoss Seam Int
License:        LGPLv2+
Group:          Development/Java
URL:            http://www.jboss.org/
# rm -rf jboss-seam-int-6.0.0 && svn export http://anonsvn.jboss.org/repos/jbossas/projects/jboss-seam-int/tags/6.0.0.GA/ jboss-seam-int-6.0.0 && tar cjf jboss-seam-int-6.0.0.tar.bz2 jboss-seam-int-6.0.0
# revision 110163.
Source0:        jboss-seam-int-%{version}.tar.bz2
Source1:        jboss-seam-int-jpp-depmap.xml
Source2:        jboss-seam-int-settings.xml
Patch0:         jboss-seam-int-vman-pom.patch

Requires(post): jpackage-utils >= 0:1.7.3
Requires(postun): jpackage-utils >= 0:1.7.3

BuildRequires:  jpackage-utils >= 0:1.7.3
BuildRequires:  maven2 >= 0:2.0.7
BuildRequires:  maven2-plugin-assembly
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
%if %with apiviz
BuildRequires:  apiviz
%endif
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven2-plugin-source
BuildRequires:  maven-deploy-plugin
BuildRequires:  maven-doxia-sitetools
BuildRequires:  maven-release-plugin
BuildRequires:  maven-site-plugin
BuildRequires:  maven-surefire-maven-plugin
BuildRequires:  maven-surefire-provider-junit
BuildRequires:  surefire-junit4
##
BuildRequires:  jboss-common-logging-spi >= 0:2.0.5
BuildRequires:  jboss-parent >= 0:4
BuildRequires:  jboss-seam2 >= 0:2.1.1
BuildRequires:  jboss-vfs2 >= 0:2.1.1
BuildRequires:  jboss-jaxb-api_2.2_spec
# FIXME: should use jbossweb2
BuildRequires:  servlet_2_5_api
BuildRequires:  junit44
BuildRequires:  jboss-test
##
#Requires:       jboss-parent >= 0:4
#Requires:       jboss-seam2 >= 0:2.1.1
Requires:       jboss-vfs2 >= 0:3.0.1

BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
JBoss Seam Int.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
%{summary}.

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%prep
%setup -q
%if %without apiviz
%patch0 -p1 
%endif

cp -p %{SOURCE2} maven2-settings.xml

sed -i -e "s|<url>__JPP_URL_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
sed -i -e "s|<url>__JAVADIR_PLACEHOLDER__</url>|<url>file://`pwd`/external_repo</url>|g" maven2-settings.xml
sed -i -e "s|<url>__MAVENREPO_DIR_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
sed -i -e "s|<url>__MAVENDIR_PLUGIN_PLACEHOLDER__</url>|<url>file://%{_datadir}/maven2/plugins</url>|g" maven2-settings.xml
sed -i -e "s|<url>__ECLIPSEDIR_PLUGIN_PLACEHOLDER__</url>|<url>file://%{_datadir}/eclipse/plugins</url>|g" maven2-settings.xml

mkdir external_repo
ln -s %{_javadir} external_repo/JPP

mkdir -p m2_repo/repository/org/jboss/seam/jboss-seam/2.2.5.EAP5
cp -p %{_javadir}/jboss-seam2/jboss-seam.jar m2_repo/repository/org/jboss/seam/jboss-seam/2.2.5.EAP5/jboss-seam-2.2.5.EAP5.jar

%build
export M2SETTINGS=`pwd`/maven2-settings.xml
export MAVEN_REPO_LOCAL=`pwd`/m2_repo/repository
export ALT_DEPLOYMENT_REPOSITORY=oss-releases::default::file:`pwd`/maven2-brew
%{_bindir}/mvn-jpp -e \
-s ${M2SETTINGS} \
-Dmaven.repo.local=${MAVEN_REPO_LOCAL} -DaltDeploymentRepository=${ALT_DEPLOYMENT_REPOSITORY} deploy javadoc:aggregate

%install
rm -rf %{buildroot}

# jars
mkdir -p %{buildroot}%{_javadir}
cp -p jbossas/target/jboss-seam-int-jbossas.jar %{buildroot}%{_javadir}/jboss-seam-int-jbossas-%{namedversion}.jar
cp -p jbossas/target/jboss-seam-int-jbossas-sources.jar %{buildroot}%{_javadir}/jboss-seam-int-jbossas-sources-%{namedversion}.jar
(cd %{buildroot}%{_javadir} && for jar in *-%{namedversion}*; do ln -s ${jar} `echo $jar| sed "s|-%{namedversion}||g"`; done)

# pom
mkdir -p %{buildroot}%{_datadir}/maven2/poms
cp -p pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP-%{name}.pom
%add_to_maven_depmap org.jboss.seam.integration jboss-seam-int %{namedversion} JPP %{name}
cp -p jbossas/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP-%{name}-jbossas.pom
%add_to_maven_depmap org.jboss.seam.integration jboss-seam-int-jbossas %{namedversion} JPP %{name}-jbossas

mkdir -p %{buildroot}%{_javadocdir}/%{name}-%{namedversion}
cp -pr target/site/apidocs/* %{buildroot}%{_javadocdir}/%{name}-%{namedversion}
ln -s %{name}-%{namedversion} %{buildroot}%{_javadocdir}/%{name}

%if %with repolib
%{__mkdir_p} %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
%{__cp} -pr maven2-brew/* %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
%endif

%clean
rm -rf %{buildroot}

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%dir %{_javadir}
%{_javadir}*/jboss-seam-int-jbossas-%{namedversion}.jar
%{_javadir}*/jboss-seam-int-jbossas.jar
%{_javadir}*/jboss-seam-int-jbossas-sources-%{namedversion}.jar
%{_javadir}*/jboss-seam-int-jbossas-sources.jar
%{_datadir}/maven2/poms/JPP-%{name}.pom
%{_datadir}/maven2/poms/JPP-%{name}-jbossas.pom
%{_mavendepmapfragdir}/%{name}

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{namedversion}
%{_javadocdir}/%{name}

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%dir %{_javadir}*
%exclude %dir %{_javadocdir}
%{_javadir}*/repository.jboss.com
%endif

%changelog
* Fri Jun 15 2012 David Walluck <dwalluck@redhat.com> 0:6.0.0-6
- fix bad prep
- fix mvn-jpp call
- fix reltag
- fix namedversion scope
- fix bad repolib file ownership
- try removing jboss-seam from jpp depmap

* Wed Apr 18 2012 Hui Wang <huwang@redhat.com> - 0:6.0.0-5.GA_redhat_1
- Cleanup
- BR jboss-test and surefire-junit4

* Thu Apr 12 2012 Lin Gao <lgao@redhat.com> - 0:6.0.0-4.GA_redhat_1
- Fix Release tag
- Remove repository definitions from POM

* Mon Mar 26 2012 Fernando Nasser <fnasser@redhat.com> - 0:6.0.0-3.GA_redhat_1.1.1
- Rebuild using cache signing

* Wed Mar 21 2012 Hui Wang <huwang@redhat.com> - 0:6.0.0-3.GA_redhat_1.1
- Fix installation path

* Fri Jan 27 2012 Fernando Nasser <fnasser@redhat.com> - 0:6.0.0-3
- Do not require jboss-seam2 and jboss-parent

* Fri Aug 26 2011 Lin Gao <lgao@redhat.com> - 0:6.0.0-2
- wolf build

* Fri Aug 12 2011 Lin Gao <lgao@redhat.com> - 0:6.0.0-1
- upgrade to 6.0.0.GA
- only jboss-seam-int-jbossas needed in EAP 6
- clean spec

* Tue Dec 14 2010 Martha Benitez <mbenitez@redhat.com> - 0:5.1.0-2
- Build with maven 2.2.1
- Change BR maven-release to maven-release-plugin
- Add BR maven-deploy-plugin, maven-site-plugin

* Fri Jun 25 2010 David Walluck <dwalluck@redhat.com> 0:5.1.0-1
- 5.1.0.GA

* Tue Jun 22 2010 David Walluck <dwalluck@redhat.com> 0:5.1.0-0.CR1.4
- rebuild with javadocs (disable apiviz)

* Tue Apr 13 2010 Yiqiao Wang <yiwang@redhat.com> 0:5.1.0-0.CR1.1.3.1
- Rebuild
- Fix depmap entry for dtdparser

* Wed Sep 16 2009 Fernando Nasser <fnasser@redhat.com> 0:5.1.0-0.CR1.1.3
- Relax run-time dependencies, all provided by the AS environment

* Mon Sep 14 2009 David Walluck <dwalluck@redhat.com> 0:5.1.0-0.CR1.1.2
- BuildRequires: hibernate3-ejb-persistence-3.0-api
- add jpp depmap entry for stax_1_0_api

* Fri Sep 11 2009 David Walluck <dwalluck@redhat.com> 0:5.1.0-0.CR1.1.1
- disable javadoc to drop apiviz requirement
- don't ignore test failures
- update jpp depmap for jbossws

* Fri Sep 11 2009 David Walluck <dwalluck@redhat.com> 0:5.1.0-0.CR1.1
- release
